package de.killig;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;

import de.killig.math.InverseDistanceSquaredMT;
import de.killig.math.Point2_5D;

public class DataCanvasMT extends Canvas {
	Point2_5D[] points;
	Rectangle2D r;
	//int n;
	int width,height;
	BufferedImage i;

	int NO_THREADS;
	double[][][] d;
	int tno;
	InverseDistanceSquaredMT[] t;

	public DataCanvasMT(Point2_5D[] points, Rectangle2D r/*, int n*/, int threads) {
		this.points=points;
		this.r=r;
		//this.n=n;
		this.NO_THREADS=threads;
		d=new double[threads][][];
		t=new InverseDistanceSquaredMT[threads];
	}
	
	/*class myRunnable implements Runnable {
		
		int id;
		
		myRunnable(int id) {
			
		}

		public void run() {
		}
		
	}*/
	
	public void paint(Graphics g) {
		double v;
		System.out.println("paint(); getWidth()="+getWidth()+"; getHeight()="+getHeight());
		if(getWidth()!=width || getHeight()!=height) {
			width=getWidth();
			height=getHeight();
			i=new BufferedImage(width,height,BufferedImage.TYPE_INT_RGB);
			long time;
			time=System.currentTimeMillis();
			//double[][] d=InverseDistanceSquared.calc(points, r, width, height/*, n*/);
			//double[][] d=InverseDistanceSquaredUnrolled.calc(points, r, width, height/*, n*/);
			//Thread thread[]=new Thread[NO_THREADS];
			for(tno=0;tno<NO_THREADS;tno++) {
				Rectangle2D r0=new Rectangle2D.Double(r.getX(),r.getY()+tno*r.getHeight()/NO_THREADS,r.getWidth(),r.getHeight()/NO_THREADS);
				t[tno]=new InverseDistanceSquaredMT(points, r0, width, height/NO_THREADS/*, n*/);
				/*thread[tno]=new Thread(Integer.toString(tno)) {
					public void run() {
						t[tno].calc();
					}
				};*/
				//System.out.println("thread["+tno+"].start()");
				//thread[tno].start();
			}
			try {
				for(tno=0;tno<NO_THREADS;tno++) {
					//thread[tno].join();
					t[tno].join();
					System.out.println("calculation: "+(System.currentTimeMillis()-time)+" ms");
					//System.out.println("t["+tno+"].getData()");
					d[tno]=t[tno].getData();
					//System.out.println("d["+tno+"]:"+d[tno]);
				}
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			time=System.currentTimeMillis();
		for(tno=0;tno<NO_THREADS;tno++) {
			int yoffset=tno*height/NO_THREADS;
			for(int y=0;y<height/NO_THREADS-1;y++) {
				/*for(int x=0;x<width;x++) {
					//v=d[x][y];
					v=(-InverseDistanceSquared.min+d[x][y])/(InverseDistanceSquared.max-InverseDistanceSquared.min);
					//v=(-InverseDistanceSquaredUnrolled.min+d[x][y])/(InverseDistanceSquaredUnrolled.max-InverseDistanceSquaredUnrolled.min);
					i.setRGB(x,height-1-y,Color.HSBtoRGB((float)v,1f,1f));
					//i.setRGB(x,height-1-y,Color.HSBtoRGB(0f,0f,(float)v));
				}*/
				for(int x=0;x<width;x++) {
					//v=d[x][y];
//System.out.println("tno="+tno+"; y="+y+"; x="+x);
					v=(-t[tno].min+d[tno][x][y])/(t[tno].max-t[tno].min);
					//v=(-InverseDistanceSquaredUnrolled.min+d[x][y])/(InverseDistanceSquaredUnrolled.max-InverseDistanceSquaredUnrolled.min);
					int ykoord=height-1-y-yoffset;
					//System.out.println(ykoord);
					i.setRGB(x,ykoord,Color.HSBtoRGB((float)v,1f,1f));
					//i.setRGB(x,height-1-y,Color.HSBtoRGB(0f,0f,(float)v));
				}
			}
		}
			System.out.println("output: "+(System.currentTimeMillis()-time)+" ms");
		}
		g.drawImage(i,0,0,null);
	}

}
